# Beaker-jobwatch

Automatically reschedule broken Beaker jobs

## Description

beaker-jobwatch is a tool that monitors given Beaker jobs and reschedules them
automatically if they fail to finish. It can guarantee that when it's finished,
you will have a complete set of results

## Features

It can detect following problems:

- aborted recipes
- external watchdog killing a recipe
- destructive task breaking the machine
- kernel panic killing the machine
- failed /distribution/install (off by default)
- failure of a user specified task (so called critical task)
- file conflict during installation

Other features:

- automatically NACKs and cancels broken recipes so they don't interfere with
  result processing tools (e.g. Beaker Matrix report)
- maximum number of reschedules to prevent resource exhaustion
- status reports including list of rescheduled recipe set
- detecting destructive tasks (tasks preventing subsequent tasks from
  executing) and removing them from jobs
- measure duration of job run (overall by default, per arch in debug mode)
- broken machine exclusion (machine that broke a recipe will not be used for
  the rescheduled recipe)

## Usage

```shell
beaker-jobwatch --job 123123,235234,TJ#1298
```
